libstdc++: std::ranges::view_interface< _Derived > Class Template Reference

libstdc++

std::ranges::view_interface< _Derived > Class Template Reference

`#include <ranges_util.h>`

Inheritance diagram for std::ranges::view_interface< _Derived >:
[legend]

## Public Member Functions
constexpr decltype(auto) | back ()
constexpr decltype(auto) | back () const
constexpr auto | cbegin ()
constexpr auto | cbegin () const
constexpr auto | cend ()
constexpr auto | cend () const
constexpr auto | data () const noexcept(noexcept(ranges::begin(_M_derived())))
constexpr auto | data () noexcept(noexcept(ranges::begin(_M_derived())))
constexpr bool | empty () const noexcept(noexcept(_S_empty(_M_derived())))
constexpr bool | empty () const noexcept(noexcept(ranges::size(_M_derived())==0))
constexpr bool | empty () noexcept(noexcept(_S_empty(_M_derived())))
constexpr bool | empty () noexcept(noexcept(ranges::size(_M_derived())==0))
constexpr decltype(auto) | front ()
constexpr decltype(auto) | front () const
constexpr | operator bool () const noexcept(noexcept(ranges::empty(_M_derived())))
constexpr | operator bool () noexcept(noexcept(ranges::empty(_M_derived())))
template<random_access_range _Range = _Derived>
constexpr decltype(auto) | operator[] (range_difference_t< _Range > __n)
template<random_access_range _Range = const _Derived>
constexpr decltype(auto) | operator[] (range_difference_t< _Range > __n) const
constexpr auto | size () const noexcept(noexcept(_S_size(_M_derived())))
constexpr auto | size () noexcept(noexcept(_S_size(_M_derived())))

## Detailed Description

template<typename _Derived>
requires is_class_v<_Derived> && same_as<_Derived, remove_cv_t<_Derived>>
class std::ranges::view_interface< _Derived >

The ranges::view_interface class template.

Definition at line 70 of file ranges_util.h.

## Member Function Documentation

## ◆ back() [1/2]

template<typename _Derived>

decltype(auto) std::ranges::view_interface< _Derived >::back | ( |  | ) |
| inlineconstexpr

Definition at line 176 of file ranges_util.h.

## ◆ back() [2/2]

template<typename _Derived>

decltype(auto) std::ranges::view_interface< _Derived >::back | ( |  | ) | const
| inlineconstexpr

Definition at line 184 of file ranges_util.h.

## ◆ cbegin() [1/2]

template<typename _Derived>

auto std::ranges::view_interface< _Derived >::cbegin | ( |  | ) |
| inlineconstexpr

Definition at line 204 of file ranges_util.h.

## ◆ cbegin() [2/2]

template<typename _Derived>

auto std::ranges::view_interface< _Derived >::cbegin | ( |  | ) | const
| inlineconstexpr

Definition at line 208 of file ranges_util.h.

## ◆ cend() [1/2]

template<typename _Derived>

auto std::ranges::view_interface< _Derived >::cend | ( |  | ) |
| inlineconstexpr

Definition at line 212 of file ranges_util.h.

## ◆ cend() [2/2]

template<typename _Derived>

auto std::ranges::view_interface< _Derived >::cend | ( |  | ) | const
| inlineconstexpr

Definition at line 216 of file ranges_util.h.

## ◆ data() [1/2]

template<typename _Derived>

auto std::ranges::view_interface< _Derived >::data | ( |  | ) | const
| inlineconstexprnoexcept

Definition at line 143 of file ranges_util.h.

## ◆ data() [2/2]

template<typename _Derived>

auto std::ranges::view_interface< _Derived >::data | ( |  | ) |
| inlineconstexprnoexcept

Definition at line 138 of file ranges_util.h.

## ◆ empty() [1/4]

template<typename _Derived>

bool std::ranges::view_interface< _Derived >::empty | ( |  | ) | const
| inlineconstexprnoexcept

Definition at line 116 of file ranges_util.h.

## ◆ empty() [2/4]

template<typename _Derived>

bool std::ranges::view_interface< _Derived >::empty | ( |  | ) | const
| inlineconstexprnoexcept

Definition at line 122 of file ranges_util.h.

## ◆ empty() [3/4]

template<typename _Derived>

bool std::ranges::view_interface< _Derived >::empty | ( |  | ) |
| inlineconstexprnoexcept

Definition at line 104 of file ranges_util.h.

## ◆ empty() [4/4]

template<typename _Derived>

bool std::ranges::view_interface< _Derived >::empty | ( |  | ) |
| inlineconstexprnoexcept

Definition at line 110 of file ranges_util.h.

## ◆ front() [1/2]

template<typename _Derived>

decltype(auto) std::ranges::view_interface< _Derived >::front | ( |  | ) |
| inlineconstexpr

Definition at line 162 of file ranges_util.h.

## ◆ front() [2/2]

template<typename _Derived>

decltype(auto) std::ranges::view_interface< _Derived >::front | ( |  | ) | const
| inlineconstexpr

Definition at line 169 of file ranges_util.h.

## ◆ operator bool() [1/2]

template<typename _Derived>

std::ranges::view_interface< _Derived >::operator bool | ( |  | ) | const
| inlineexplicitconstexprnoexcept

Definition at line 133 of file ranges_util.h.

## ◆ operator bool() [2/2]

template<typename _Derived>

std::ranges::view_interface< _Derived >::operator bool | ( |  | ) |
| inlineexplicitconstexprnoexcept

Definition at line 128 of file ranges_util.h.

## ◆ operator[]() [1/2]

template<typename _Derived>
template<random_access_range _Range = _Derived>

decltype(auto) std::ranges::view_interface< _Derived >::operator[] | ( | range_difference_t< _Range > | __n | ) |
| inlineconstexpr

Definition at line 194 of file ranges_util.h.

## ◆ operator[]() [2/2]

template<typename _Derived>
template<random_access_range _Range = const _Derived>

decltype(auto) std::ranges::view_interface< _Derived >::operator[] | ( | range_difference_t< _Range > | __n | ) | const
| inlineconstexpr

Definition at line 199 of file ranges_util.h.

## ◆ size() [1/2]

template<typename _Derived>

auto std::ranges::view_interface< _Derived >::size | ( |  | ) | const
| inlineconstexprnoexcept

Definition at line 155 of file ranges_util.h.

## ◆ size() [2/2]

template<typename _Derived>

auto std::ranges::view_interface< _Derived >::size | ( |  | ) |
| inlineconstexprnoexcept

Definition at line 149 of file ranges_util.h.

The documentation for this class was generated from the following files:

- ranges_base.h
- ranges_util.h